package review.calculette;

import java.util.InputMismatchException;

public class Calculette {

    private int a;
    private int b;
    private char op;

    /** constructeur definit les valeurs par default pour les operands et 
     * l'operateur. 
     */
    public Calculette() {
        a = 0;
        b = 0;
        op = '+';
    }
    
    public Calculette (int valA, int valB, char op) {
        a = valA;
        b = valB;
        this.op = op;
    }

    public int getA() {
        return a;
    }

    public int getB() {
        return b;
    }

    public void setOperands(int valA, int valB) {
        this.a = valA;
        this.b = valB;
    }

    public char getOperation() {
        return op;
    }

    public void setOperation(char val) {
        this.op = val;
    }

    /** calcul method executes the defined calcul. 
     * @return result of the defined operation over the operands
     * @throws InputMismatchException if operation is unknown
     */
    public int calcul() throws InputMismatchException {
        int r = 0;

        switch (this.op) {
            case '+':
                r = this.somme();
                break;
            case '-':
                r = this.soustraction();
                break;
            case 'x':
            case 'X':
                r = this.multiplication();
                break;
            case '/':
                r = this.division();
                break;
            default:
                throw new InputMismatchException("Unkwon operation");
        }

        return r;

    }

    protected int somme() {
        return a + b;
    }

    protected int soustraction() {
        return a - b;
    }

    protected int multiplication() {
        return a * b;
    }

    protected int division() {
        return a / b;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Calculette other = (Calculette) obj;
        if (this.a != other.a) {
            return false;
        }
        if (this.b != other.b) {
            return false;
        }
        if (this.op != other.op) {
            return false;
        }
        return true;
    }
    
}
