/*
 * This software was created for education purposes.
 * Copy, modification and distribution are allowed 
 * only if original authors are indicated.  
 */
package review.calculette;

import java.util.InputMismatchException;

/**
 * Universite Paris 1 - Pantheon Sorbonne / Formation MIAGE 
 * @author kirsch
 */
public class CalculetteTexte {

    Calculette c;

    public CalculetteTexte() {
        this.c = new Calculette();
    }

    public Calculette getCalculette() {
        return c;
    }

    public void set(char op, int a, int b) {
        this.c.setOperation(op);
        this.c.setOperands(a, b);
    }

    public int calcul() {
        int r = 0;

        try {
            r = this.c.calcul();
        } catch (InputMismatchException e) {
            System.out.println("Error : Only +,-,/,x operations are allowed!");
        }
        return r;
    }

    public static void main(String[] args) {

        if (args.length >= 3) {
            System.out.println("calculating " + args[1] + args[0].charAt(0) + args[2]);

            char o;
            int a, b, r;

            o = args[0].charAt(0);

            try {
                a = Integer.parseInt(args[1]);
                b = Integer.parseInt(args[2]);
            } catch (NumberFormatException nfe) {
                System.out.println("Error : Only integers are allowed!");
                a = 0;
                b = 0;
            }

            CalculetteTexte calcul = new CalculetteTexte();
            calcul.set(o, a, b);

            r = calcul.calcul();

            System.out.println(r);
        }
    }
}
